#ifndef __TASKBARBUTTON_H
#define __TASKBARBUTTON_H

#include <string>
#include <vector>
#include "../current/lsapi/lsapi.h"
#include "taskbar.h"
#include "taskbarskin.h"
#include "utilities.h"
#include "bangs.h"
#include "AggressiveOptimize.h"
using namespace std;

class TaskbarButton
{
	friend class Taskbar;
private:

	//boolean active;
	HICON icon;

	char* otherCaption;
	TaskbarSkin* skin;
	TaskbarSkin* activeskin;
	TaskbarSkin* flashskin;
	TaskbarSkin* minimizedskin;

	HWND hTask;

	LPSTR caption;

	//BOOL mousePressed;
	BOOL mouseOver;
	BOOL taskflash; //current state

	int x;
	int y;
	int height;
	int width;

	Taskbar &container;

public:
	int currentState;
	int getCurrentState(bool);
	void SetCaption(LPCSTR cap);
	TaskbarSkin* GetSkin();
	TaskbarSkin* GetActiveSkin();
	TaskbarSkin* GetFlashSkin();
	TaskbarSkin* GetMinimizedSkin();
	void SetSkin(TaskbarSkin *s);
	void SetActiveSkin(TaskbarSkin *s);
	void SetFlashSkin(TaskbarSkin *s);
	void SetMinimizedSkin(TaskbarSkin *s);

	TaskbarButton( Taskbar &, HWND );
	virtual ~TaskbarButton();

	BOOL HasPoint( int, int );
	void Move( int, int, int, int );

	void OnLButtonDown( int, int );
	void OnMButtonDown( int, int );
	void OnMButtonUp( int, int );
	bool isOnTop;

	void Close();
	void Close2();
    void SelectUp();
    void SelectDown();
	void MenuUp();
	void MenuDown();
	void OnTopToggle();
	void OnLButtonUp( int, int );
	void OnMouseMove( int, int );
	void OnPaint( HDC );
	void OnRButtonDown( int, int );
	void OnRButtonUp( int, int );

	BOOL flashing;
	HWND buttonHandler();

	// redraw == TRUE to force ths button to update
	//			 FALSE to let the button decide whether to update or not
	void OnUpdate(BOOL needRedraw = FALSE);

	/*inline BOOL IsActive() const
	{
		return active ? TRUE : FALSE;
	}*/

	bool flashingFlashSkin;

	void SetFlashing(BOOL flash)
	{
		taskflash = flash;
	}

	BOOL GetFlashing() const
	{
		return taskflash;
	}

	bool windowIsActive(HWND);

private:

	LPSTR GetWindowCaption();
	HICON GetIcon();

}
;

#endif